/**************************************************************************
*  Copyright (c) 2015 by Michael Fischer (www.emb4fun.de).
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*  
*  1. Redistributions of source code must retain the above copyright 
*     notice, this list of conditions and the following disclaimer.
*
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the 
*     documentation and/or other materials provided with the distribution.
*
*  3. Neither the name of the author nor the names of its contributors may 
*     be used to endorse or promote products derived from this software 
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
*  SUCH DAMAGE.
*
***************************************************************************
*  History:
*
*  27.06.2015  mifi  First Version.
*  13.03.2016  mifi  Renamed to web_cgi.c.
**************************************************************************/
#define __WEB_CGI_C__

/*=======================================================================*/
/*  Includes                                                             */
/*=======================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <time.h>

#include "tcts.h"
#include "ipstack.h"
#include "ipweb.h"
#include "mod_cgi.h"

#if !defined(IP_WEB_CGI_EXT_CST) 
#define _IP_WEB_CGI_EXT_CST   0
#else
#define _IP_WEB_CGI_EXT_CST   IP_WEB_CGI_EXT_CST
#endif

#if (_IP_WEB_CGI_EXT_CST >= 1)
#include "web_cgi_ext_cst.h"
#endif

static const CGI_LIST_ENTRY CGIList[];

/*=======================================================================*/
/*  All extern data                                                      */
/*=======================================================================*/

/*=======================================================================*/
/*  All Structures and Common Constants                                  */
/*=======================================================================*/

/*=======================================================================*/
/*  Definition of all global Data                                        */
/*=======================================================================*/

/*=======================================================================*/
/*  Definition of all local Data                                         */
/*=======================================================================*/

/*=======================================================================*/
/*  Definition of all local Procedures                                   */
/*=======================================================================*/

/*=======================================================================*/
/*  All code exported                                                    */
/*=======================================================================*/

/*************************************************************************/
/*  web_CGIInit                                                          */
/*                                                                       */
/*  In    : none                                                         */
/*  Out   : none                                                         */
/*  Return: none                                                         */
/*************************************************************************/
void web_CGIInit (void)
{
   CGI_LIST_ENTRY *pList = (CGI_LIST_ENTRY*)CGIList;
   
   while(pList->Var != NULL)
   {
      HttpRegisterCgiFunction(pList->Var,  pList->pFunc);
   
      pList++;
   }

} /* web_CGIInit */

/*************************************************************************/
/*  web_SendCGIHeader                                                    */
/*                                                                       */
/*  In    : hs                                                           */
/*  Out   : none                                                         */
/*  Return: none                                                         */
/*************************************************************************/
void web_SendCGIHeader (HTTPD_SESSION *hs)
{
   HttpSendHeaderTop(hs, 200);
   s_puts("Cache-Control: no-cache, must-revalidate\r\n", hs->s_stream);
   s_puts("Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n", hs->s_stream);   
   HttpSendHeaderBottom(hs, "application", "octet-stream", -1, 0);   
} /* web_SendCGIHeader */

/*
 * CGI variable list
 */
static const CGI_LIST_ENTRY CGIList[] =
{

#if (_IP_WEB_CGI_EXT_CST >= 1)
   WEB_CGI_EXT_CST
#endif  
      
   {NULL, NULL}
};

/*** EOF ***/
